;====================================================================
.model small, c
.stack
.data
.code
;====================================================================
setpixel proc uses ax bx cx dx x:word, y:word, color:byte
    mov ah, 0ch
    mov al, color
    xor bh, bh
    mov cx, x
    mov dx, y
    int 10h
    ret
setpixel endp
;====================================================================
drawball proc x:word, y:word
    ;----------------------------------------
    ; Note that bit 7 of color value is set.
    ;----------------------------------------
    invoke SetPixel, x, y, 82h
    inc x
    invoke SetPixel, x, y, 82h
    inc y
    dec x
    invoke SetPixel, x, y, 82h
    inc x
    invoke SetPixel, x, y, 82h
    ret
drawball endp
;====================================================================
delay proc uses ax cx ms:word
    mov cx, ms
  msLoop:
    push cx               ; preserve msLoop counter
    mov cx, 34            ; load repeat count
  wait1:
    in  al, 61h           ; read byte from port
    test al, 10h          ; test bit 4
    jz  wait1             ; jump if bit clear
  wait2:
    in  al, 61h           ; read byte from port
    test al, 10h          ; test bit 4
    jnz wait2             ; jump if bit not clear
    dec cx                ; decrement repeat count
    jnz wait1             ; jump if count not zero
    pop cx                ; recover msLoop counter
    dec cx                ; decrement msLoop count
    jnz msLoop            ; jump if count not zero
    ret
delay endp
;====================================================================
.startup
;====================================================================

    mov ax, 4
    int 10h
    mov ah, 0bh
    mov bx, 1
    int 10h
    mov ah, 0bh
    mov bx, 0101h
    int 10h

    invoke delay, 3000

    xor si, si
    invoke drawball, 100, si   ; draw at starting coordinates
    mov cx, 198
  @@:
    invoke drawball, 100, si   ; draw at old coordinates to erase
    inc si
    invoke drawball, 100, si   ; draw at new coordinates
    invoke delay, 70
    dec cx
    jnz @b

    xor ah, ah
    int 16h

;====================================================================
.exit
end